"Python3 program to make metafile using tkinter."

##  METAGET :
##
##  Second attempt at Python3 program to make a metafile with Tkinter :
##  Copyright 2015 R.S. Forsyth.
##  first version : 25/02/2015
##  last revision : 15/05/2015


import  math, os, string, sys
import  re, time
import  tkinter as tk
import  tkinter.messagebox as mbox
from tkinter.filedialog import askopenfilenames


##  Globals :
Version = "1.1"
Feff = "\ufeff"  ##  nasty byte-mark left by Windows
Htab = '\t'
##  using globals naughty but necessary, given my ignorance :
Filelist = []
Basepath = os.path.realpath('.') + "\\" ##  current folder
Metafile = Basepath + "metazero.txt"
Catcode = "00"  ##  initial default value
Initdir = Basepath
if os.path.isdir(".."):
    Initdir = os.path.realpath("..")  ##  1 level up
Boxwidth = 26


##
##  Main line :
def main():
    "Main line."

    ##  First some odds & ends concerned with orientation :
    args = sys.argv[:]          ##  gets command-line arguments
    na = len(args)
    progname = args[0]
    dateline = time.asctime(time.localtime(time.time()))
    print(progname,Version,dateline)
    print("command-line args. =",na)
    t1 = time.time()  ##  start time
    print(Initdir)
    cc = fc = 0

    ##  draw main window & frame :
    main.root = root = tk.Tk()
    root.title("Metafile creation.")
    root.geometry("480x360")
    main.fr = fr = tk.Frame(root)
    main.clab = tk.Label(main.root,text=Catcode)
    main.clab.pack(side=tk.BOTTOM)
    main.flab = tk.Label(main.root,text=Metafile)
    main.flab.pack(side=tk.TOP)
    main.nlab = tk.Label(main.root,text='')
    main.nlab.pack(side=tk.RIGHT)
    ##  place labels :
    ##  First text category name :
    catlab = tk.Label(fr,text="Enter next category name :")
    fr.pack(padx=16,pady=16,side=tk.LEFT)
    catlab.grid(row=1,column=1,pady=16)
    main.ecat = ecat = tk.Entry(fr,width=Boxwidth)
    ecat.grid(row=1,column=2)
    catbutt = tk.Button(fr,text="Enter",command=clabsub)
    catbutt.grid(row=1,column=3)
    ##  Second file selection option :
    filelab = tk.Label(fr,text="Select file(s) :")
    filelab.grid(row=2,column=1,pady=16)
    filebut = tk.Button(fr,text="Choose",command=filesub)
    filebut.grid(row=2,column=3)
    ##  Third output metafile name :
    metalab = tk.Label(fr,text="Enter output metafile name:")
    main.emet = emet = tk.Entry(fr,width=Boxwidth)
    metabut = tk.Button(fr,text="Enter",command=metasub)
    metalab.grid(row=3,column=1,pady=16)
    emet.grid(row=3,column=2)
    metabut.grid(row=3,column=3)
    ##  Last exit button :
    quitlab = tk.Label(fr,text="Exit & save metafile :")
    quitbut = tk.Button(fr,text="Quit.",command=quitsub)
    quitlab.grid(row=4,column=1,pady=16)
    quitbut.grid(row=4,column=3)    
    
    root.mainloop()
 
    ##  gets here on window exit; does the actual business :
    try:
        metafile = open(Metafile,'w',encoding="utf-8")
    except IOError as xxxx:
        metafile = open(Basepath + "metazero.txt",'w',encoding="utf-8")
        print(xxxx)
        print(metafile.name,"opened instead.")
    ##  first write header :
    print("prepath"+Htab+"filename"+Htab+"doctype",file=metafile)
    fc = cc = 0  ##  just 2b safe
    catname = Catcode or "00"
    cset = set()
    for item in Filelist:
        c = ''
        if type(item) == tuple:
            f,c = item
            if not c:
                c = catname
            hd,tl = os.path.split(f)
            hd = hd.replace('/',os.sep) + os.sep  ##  optional ??
            print(hd,tl,c,file=metafile,sep=Htab)
            cset.add(c)
            fc += 1
        else:
            catname = item
            print(item)
            cc += 1
    metafile.close()
    if fc < 1:  ##  didn't work, so clean filespace
        os.remove(Metafile)
    
    print("Number of files written =",fc)
    print("Number of categories =",len(cset))
    print("Metafile :",Metafile)
    dateline = time.asctime(time.localtime(time.time()))
    print(dateline)
    print("done after",round(time.time()-t1,4),"secs.")
    ##  won't be seen if activated by clicking ?

    return 0



##  FILESUB :
def filesub ():
    "gets file selectipon from user & adds to Filelist."
    global  Catcode,Filelist

    if len(Filelist) < 10:  ##  no need to keep repeating (?)
        mbox.showinfo("File selection :","pick files then click Open.")
    namelist = askopenfilenames(title="Picking "+Catcode+" files.",
                                filetypes=( ("text files",".txt"),
                                            ("all files",".*") ),
                                initialdir=Initdir)
    if type(namelist) == tuple:  ##  v3.4 ??
        filelist = list(namelist)
    elif type(namelist) == list:
        filelist = namelist
    else:  ##  string, as in v3.2 ??
        nn = namesep(namelist)
        ##  print(nn)
        filelist = sorted(nn.split(Htab))
    for f in filelist:
        ##  print(f)
        Filelist.append((f,Catcode))
    fc = 0
    for f in Filelist:
        if type(f) == tuple:
            fc += 1
    ##  print('#',fc)
    main.nlab.config(text="n = "+str(fc))

    return


##  NAMESEP :
def namesep (namestr):
    "separates file names as returned by askopenfilenames."

    namesout = ''  ##  will have names with Htab delimiters
    brax = 0
    print("!!",namestr)
    for ch in namestr:
        if ch == '{':
            brax += 1
        elif ch == '}':
            brax -= 1
        elif ch == ' ' and brax == 0:  ##  blank outside braces
            namesout = namesout + Htab
        else:
            namesout = namesout + ch

    return  namesout


##  METASUB :
def metasub ():
    "gets metafile o/p name from user."
    global  Metafile

    Metafile = main.emet.get()
    mbox.showinfo("Metafile name :",Metafile.ljust(Boxwidth))
    main.flab.config(text=Metafile)

    return


##  CLABSUB :
def clabsub ():
    "gets category name."
    global  Catcode

    Catcode = main.ecat.get()
    mbox.showinfo("Current category",Catcode.ljust(26))
    Filelist.append(Catcode)
    ##  if hasattr(main,"clab"):
        ##  main.clab.destroy()
    ##  main.clab = tk.Label(main.root,text=Catcode)
    ##  main.clab.pack(side=tk.BOTTOM)
    main.clab.config(text=Catcode)

    return


##  QUITSUB :
def quitsub ():
    "exits from main menu loop."

    mbox.showinfo("Finish :",Metafile+" will be written.")
    main.root.destroy()
    return  ##  no args, no result.



    
##  Call main and attempt to honour exit status:
if __name__ == "__main__":
    try:
        main()
    except KeyboardInterrupt:
        sys.exit(1)

